/* Generated by G-Wrap: an experimental C->Guile wrapper engine */

#include <guile/gh.h>
#include <libguile.h>
#include <string.h>
#include <g-wrap-compatibility.h>

#include "bar-gwrap.h"
#include "bar.h"
enum GW__ErrorStatus
{
  GW__ERR_NONE,
  GW__ERR_MISC,
  GW__ERR_MEMORY,
  GW__ERR_RANGE,
  GW__ERR_TYPE,
  GW__ERR_ARGC,
  GW__ERR_ARG_RANGE,
  GW__ERR_ARG_TYPE
};
 
static void
gw__handle_wrapper_error(enum GW__ErrorStatus status,
                         const char *func_name,
                         unsigned int arg_pos,
                         const char *misc_msg,
                         SCM scm_data) __attribute__ ((noreturn));

static void
gw__handle_wrapper_error(enum GW__ErrorStatus status,
                         const char *func_name,
                         unsigned int arg_pos,
                         const char *misc_msg,
                         SCM scm_data)
{
  static SCM out_of_range_key = SCM_BOOL_F;
  static SCM wrong_type_key = SCM_BOOL_F;

  if(SCM_FALSEP(out_of_range_key))
    out_of_range_key = scm_permanent_object(scm_c_make_keyword("out-of-range"));
  if(SCM_FALSEP(wrong_type_key))
    wrong_type_key = scm_permanent_object(scm_c_make_keyword("wrong-type"));

  switch(status) {
  case GW__ERR_NONE:
    scm_misc_error(func_name,
                   "asked to handle error when there wasn't one",
                   SCM_EOL);
    break;
  case GW__ERR_MISC:
    /* scm_data is a list of format args for misc_msg */
    scm_misc_error(func_name, misc_msg, scm_data); break;
  case GW__ERR_MEMORY:
    scm_memory_error(func_name); break;
  case GW__ERR_RANGE:
    scm_error (out_of_range_key,
	       func_name,
	       "Out of range: ~S",
               scm_cons (scm_data, SCM_EOL),
	       SCM_BOOL_F);
    break;
  case GW__ERR_TYPE:
    scm_error(wrong_type_key,
              func_name,
              "Wrong type: ",
              scm_cons (scm_data, SCM_EOL),
              SCM_BOOL_F);
    break;
  case GW__ERR_ARGC:
    scm_wrong_num_args(scm_makfrom0str(func_name)); break;
  case GW__ERR_ARG_RANGE:
    /* scm_data is the bad arg */
    scm_out_of_range(func_name, scm_data); break;
  case GW__ERR_ARG_TYPE:
    /* scm_data is the bad arg */
    scm_wrong_type_arg(func_name, arg_pos, scm_data); break;
  default:
    scm_misc_error(func_name,
                   "asked to handle nonexistent gw:error type: ~S",
                   scm_cons(scm_long2num(status), SCM_EOL));    
    break;
  };
  exit(1);
}
static char * gw__tmp7_bar_hello_namestr = "bar:hello";
static SCM gw__tmp6_bar_hello_wrapper  () {
  SCM gw__scm_result = SCM_UNSPECIFIED;
  enum GW__ErrorStatus gw__error_status = GW__ERR_NONE;
  SCM gw__error_data = SCM_UNSPECIFIED;
  unsigned int gw__arg_pos = 0;
  const char *gw__error_misc_msg = NULL;
int gw__c_result;

if (gw__error_status == GW__ERR_NONE)
{
  /* no pre-call result code requested! */
if (gw__error_status != GW__ERR_NONE) goto gw__wrapper_exit;
SCM_DEFER_INTS;
gw__c_result = bar_hello ();
SCM_ALLOW_INTS;
{
gw__scm_result= (gw__c_result) ? SCM_BOOL_T : SCM_BOOL_F;
}
}
 gw__wrapper_exit:
  if(gw__error_status != GW__ERR_NONE)
    gw__handle_wrapper_error(gw__error_status,
                             gw__tmp7_bar_hello_namestr,
                             gw__arg_pos,
                             gw__error_misc_msg,
                             gw__error_data);
  return gw__scm_result;
}
void
gw_init_wrapset_bar_gwrap() {
  static int gw_wrapset_initialized = 0;

  if(!gw_wrapset_initialized)
  {
    gh_eval_str("(use-modules (g-wrap runtime))");
    gh_eval_str("(gw:wrapset-register-runtime \"bar-gwrap\")");

gh_eval_str("(use-modules (g-wrap gw-standard))");
{
   enum GW__ErrorStatus gw__tmp8_status_var = GW__ERR_NONE;
   SCM gw__tmp10_err_data = SCM_UNSPECIFIED;
   char *gw__tmp9_err_misc_msg = NULL;
   (void) gw__tmp8_status_var;
   (void) gw__tmp10_err_data;
   (void) gw__tmp9_err_misc_msg;
}
{
   enum GW__ErrorStatus gw__tmp11_err_status = GW__ERR_NONE;
   SCM gw__tmp13_err_data = SCM_UNSPECIFIED;
   char *gw__tmp12_err_misc_msg = NULL;
   (void) gw__tmp11_err_status;
   (void) gw__tmp13_err_data;
   (void) gw__tmp12_err_misc_msg;
}
{
   enum GW__ErrorStatus gw__tmp14_status_var = GW__ERR_NONE;
   SCM gw__tmp16_err_data = SCM_UNSPECIFIED;
   char *gw__tmp15_err_misc_msg = NULL;
   (void) gw__tmp14_status_var;
   (void) gw__tmp16_err_data;
   (void) gw__tmp15_err_misc_msg;
    gh_new_procedure(gw__tmp7_bar_hello_namestr,
                     (SCM (*) ()) gw__tmp6_bar_hello_wrapper,
                     0,
                     0,
                     0);

if (gw__tmp14_status_var != GW__ERR_NONE)  gw__handle_wrapper_error (gw__tmp14_status_var,
                            "gw_init_wrapset_bar_gwrap",
                            0,
                            gw__tmp15_err_misc_msg,
                            gw__tmp16_err_data);
}
    gw_wrapset_initialized = 1;
    (void) gw__handle_wrapper_error;
  }
}
